HDU-4035 Maze(期望dp)

Maze

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others)
Total Submission(s): 2716    Accepted Submission(s): 1154
Special Judge


Problem Description
When wake up, lxhgww find himself in a huge maze.

The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.

Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room).
What is the expect number of tunnels he go through before he find the exit?
 

Input
First line is an integer T (T ≤ 30), the number of test cases.

At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.

Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.

Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.
 

Output
For each test case, output one line “Case k: ”. k is the case id, then the expect number of tunnels lxhgww go through before he exit. The answer with relative error less than 0.0001 will get accepted. If it is not possible to escape from the maze, output “impossible”.
 

Sample Input
  
  
3 3 1 2 1 3 0 0 100 0 0 100 3 1 2 2 3 0 0 100 0 0 100 6 1 2 2 3 1 4 4 5 4 6 0 0 20 30 40 30 50 50 70 10 20 60
 

Sample Output
  
  
Case 1: 2.000000 Case 2: impossible Case 3: 2.895522


题意:
    有n个房间,由n-1条隧道连通起来,实际上就形成了一棵树,从结点1出发,开始走,在每个结点i都有3种可能:
        1.被杀死,回到结点1处(概率为ki)
        2.找到出口,走出迷宫 (概率为ei)
        3.和该点相连有m条边,随机走一条

    求:走出迷宫所要走的边数的期望值。


题解:

叶子节点:
E[i] = (1-e[i]-k[i])(E[fa]+1) + k[i]*E[1]
      = k[i]*E[1] + (1-e[i]-k[i])*E[fa] + (1-e[i]-k[i])


非叶子节点:
E[i] = k[i]*E[1] + (1-e[i]-k[i])/m*{E[fa]+∑E[j]} + (1-e[i]-k[i])
     = k[i]*E[1] + (1-e[i]-k[i])/m*E[fa] + (1-e[i]-k[i]) + (1-e[i]-k[i])/m*∑E[j]


对于所有节点:
E[i] = A[i]*E[1] + B[i]*E[fa] + C[i]


非叶子节点:
∑E[j] = ∑(A[j]*E[1] + B[j]*E[fa] + C[j])
         = ∑(A[j]*E[1] + B[j]*E[i] + C[j])


E[i] = k[i]*E[1] + (1-e[i]-k[i])/m*E[fa] + (1-e[i]-k[i]) + (1-e[i]-k[i])/m*∑(A[j]*E[1] + B[j]*E[i] + C[j])

      = {k[i]+(1-e[i]-k[i])/m*∑(A[j]}E[1] + (1-e[i]-k[i])/m*E[fa] + (1-e[i]-k[i])/m*(m+∑C[j]) + (1-e[i]-k[i])/m*∑B[j]*E[i]



得到:
{1-(1-e[i]-k[i])/m*∑B[j]}E[i] = {k[i]+(1-e[i]-k[i])/m*∑(A[j]}E[1] + (1-e[i]-k[i])/m*E[fa] + (1-e[i]-k[i])/m*(m+∑c[j])


非叶子节点:
A[i] = {k[i]+(1-e[i]-k[i])/m*∑(A[j]}            / {1-(1-e[i]-k[i])/m*∑B[j]}
B[i] = (1-e[i]-k[i])/m                               / {1-(1-e[i]-k[i])/m*∑B[j]}
C[i] = (1-e[i]-k[i])+(1-e[i]-k[i])/m*∑c[j])   / {1-(1-e[i]-k[i])/m*∑B[j]}


叶子节点:
A[i] = k[i]
B[i] = (1-e[i]-k[i])
C[i] = (1-e[i]-k[i])


答案:E[1]=A[1]*E[1]+E[1]*E[0]+C[1],E[0]=0
所以E[1]=C[1]/(1-A[1])
如果1-(1-e[i]-k[i])/m*∑B[j]=0或1-A[1]=0则输出impossible

/*
叶子节点:
E[i] = (1-e[i]-k[i])(E[fa]+1) + k[i]*E[1]
     = k[i]*E[1] + (1-e[i]-k[i])*E[fa] + (1-e[i]-k[i])

非叶子节点:
E[i] = k[i]*E[1] + (1-e[i]-k[i])/m*{E[fa]+∑E[j]} + (1-e[i]-k[i])
     = k[i]*E[1] + (1-e[i]-k[i])/m*E[fa] + (1-e[i]-k[i]) + (1-e[i]-k[i])/m*∑E[j]

对于所有节点:
E[i] = A[i]*E[1] + B[i]*E[fa] + C[i]

非叶子节点:
∑E[j] = ∑(A[j]*E[1] + B[j]*E[fa] + C[j])
      = ∑(A[j]*E[1] + B[j]*E[i] + C[j])

E[i] = k[i]*E[1] + (1-e[i]-k[i])/m*E[fa] + (1-e[i]-k[i]) + (1-e[i]-k[i])/m*∑(A[j]*E[1] + B[j]*E[i] + C[j])
     = {k[i]+(1-e[i]-k[i])/m*∑(A[j]}E[1] + (1-e[i]-k[i])/m*E[fa] + (1-e[i]-k[i])/m*(m+∑C[j]) + (1-e[i]-k[i])/m*∑B[j]*E[i]

得到:
{1-(1-e[i]-k[i])/m*∑B[j]}E[i]={k[i]+(1-e[i]-k[i])/m*∑(A[j]}E[1] + (1-e[i]-k[i])/m*E[fa] + (1-e[i]-k[i])/m*(m+∑c[j])

非叶子节点:
A[i] = {k[i]+(1-e[i]-k[i])/m*∑(A[j]} 	    / {1-(1-e[i]-k[i])/m*∑B[j]}
B[i] = (1-e[i]-k[i])/m 		      		    / {1-(1-e[i]-k[i])/m*∑B[j]}
C[i] = (1-e[i]-k[i])+(1-e[i]-k[i])/m*∑c[j]) / {1-(1-e[i]-k[i])/m*∑B[j]}

叶子节点:
A[i] = k[i]
B[i] = (1-e[i]-k[i])
C[i] = (1-e[i]-k[i])

答案:E[1]=A[1]*E[1]+E[1]*E[0]+C[1],E[0]=0
      E[1]=C[1]/(1-A[1])
如果1-(1-e[i]-k[i])/m*∑B[j]=0或1-A[1]=0则输出impossible

*/
#include<bits/stdc++.h>
using namespace std;
const int MX = 1e4 + 5;
const double eps = 1e-9;
vector<int>E[MX];
double e[MX],k[MX],A[MX],B[MX],C[MX];
int fa[MX],IN[MX];
bool dfs(int u,int fa){
    int m=E[u].size();
    double rat=1-e[u]-k[u],div=0;
    A[u]=k[u];
    B[u]=rat/m;
    C[u]=rat;
    for(int i=0;i<m;i++){
        int v=E[u][i];
        if(v==fa) continue;
        if(!dfs(v,u)) return 0;
        A[u]+=rat*A[v]/m;
        C[u]+=rat*C[v]/m;
        div+=rat*B[v]/m;
    }
    div=1-div;
    if(fabs(div)<eps) return 0;
    A[u]/=div;
    B[u]/=div;
    C[u]/=div;
    return 1;
}
int main(){
    int T,n;
    //freopen("in.txt","r",stdin);
    scanf("%d",&T);
    for(int cas=1;cas<=T;cas++){
        scanf("%d",&n);
        for(int i=1;i<=n;i++) {
            E[i].clear();
            IN[i]=0;
            fa[i]=0;
        }
        for(int i=1;i<n;i++){
            int u,v;
            scanf("%d%d",&u,&v);
            E[u].push_back(v);
            E[v].push_back(u);
            IN[u]++;IN[v]++;
        }
        for(int i=1;i<=n;i++) {
            scanf("%lf%lf",&k[i],&e[i]);
            k[i]/=100;
            e[i]/=100;
        }
        printf("Case %d: ",cas);
        if(!dfs(1,0)||fabs(1-A[1])<eps) printf("impossible\n");
        else printf("%.6f\n",C[1]/(1-A[1]));
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值